package eu.eudat.controllers;

import eu.eudat.managers.InvitationsManager;
import eu.eudat.models.helpers.responses.ResponseItem;
import eu.eudat.models.invitation.Invitation;
import eu.eudat.models.userinfo.UserInfoInvitationModel;
import eu.eudat.models.userinfo.UserInfoRequestItem;
import eu.eudat.services.ApiContext;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/**
 * Created by ikalyvas on 1/4/2018.
 */
@RequestMapping("invite/")
@RestController
@CrossOrigin
public class UserInvitationController extends BaseController{

    @Autowired
    public UserInvitationController(ApiContext apiContext) {
        super(apiContext);
    }

    @RequestMapping(method = RequestMethod.POST, value = { "/users" }, consumes = "application/json", produces="application/json")
    public @ResponseBody ResponseItem<Invitation> users(@RequestBody Invitation invitation) {
        try {
            InvitationsManager.inviteUsers(this.getApiContext(),invitation);
            return new ResponseItem<Invitation>().message("Users have beeen invited");
        } catch (Exception e) {
            return new ResponseItem<Invitation>().message(e.getMessage());
        }
    }

    @RequestMapping(method = RequestMethod.POST, value = { "/getUsers" }, consumes = "application/json", produces="application/json")
    public @ResponseBody ResponseItem<List<UserInfoInvitationModel>> getUsers(@RequestBody UserInfoRequestItem userInfoRequestItem) {
        try {
            List<UserInfoInvitationModel> users = InvitationsManager.getUsers(this.getApiContext(),userInfoRequestItem);
            return new ResponseItem<List<UserInfoInvitationModel>>().payload(users);
        } catch (Exception e) {
            return new ResponseItem<List<UserInfoInvitationModel>>().message(e.getMessage());
        }
    }
}
